---
title: X-Content-Type-Options
slug: Web/HTTP/Headers/X-Content-Type-Options
tags:
  - HTTP
  - HTTP Header
  - Reference
  - Response Header
---
<div>{{HTTPSidebar}}</div>

<p>The <code><strong>X-Content-Type-Options</strong></code> response HTTP header is a marker used by the server to indicate that the <a href="/en-US/docs/Web/HTTP/Basics_of_HTTP/MIME_types">MIME types</a> advertised in the {{HTTPHeader("Content-Type")}} headers should not be changed and be followed. This is a way to opt out of <a href="/en-US/docs/Web/HTTP/Basics_of_HTTP/MIME_types#MIME_sniffing">MIME type sniffing</a>, or, in other words, to say that the MIME types are deliberately configured.</p>

<p>This header was introduced by Microsoft in IE 8 as a way for webmasters to block content sniffing that was happening and could transform non-executable MIME types into executable MIME types. Since then, other browsers have introduced it, even if their MIME sniffing algorithms were less aggressive.</p>

<p>Starting with Firefox 72, the opting out of MIME sniffing is also applied to top-level documents if a {{HTTPHeader("Content-type")}} is provided. This can cause HTML web pages to be downloaded instead of being rendered when they are served with a MIME type other than <code>text/html</code>. Make sure to set both headers correctly.</p>

<p>Site security testers usually expect this header to be set.</p>

<p class="notecard note">Note: <code>X-Content-Type-Options</code> only apply <a href="https://fetch.spec.whatwg.org/#should-response-to-request-be-blocked-due-to-nosniff?">request-blocking due to <code>nosniff</code></a> for <a href="https://fetch.spec.whatwg.org/#concept-request-destination">request destinations</a> of "<code>script</code>" and "<code>style</code>". However, it also <a href="https://chromium.googlesource.com/chromium/src/+/master/services/network/cross_origin_read_blocking_explainer.md#determining-whether-a-response-is-corb_protected">enables Cross-Origin Read Blocking (CORB)</a> protection for HTML, TXT, JSON and XML files (excluding SVG <code>image/svg+xml</code>).</p>

<table class="properties">
 <tbody>
  <tr>
   <th scope="row">Header type</th>
   <td>{{Glossary("Response header")}}</td>
  </tr>
  <tr>
   <th scope="row">{{Glossary("Forbidden header name")}}</th>
   <td>no</td>
  </tr>
 </tbody>
</table>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox">X-Content-Type-Options: nosniff
</pre>

<h2 id="Directives">Directives</h2>

<dl>
 <dt><code>nosniff</code></dt>
 <br>
 <dd>Blocks a request if the request destination is of type:
 <ul>
  <li>"<code>style</code>" and the MIME type is not <code>text/css</code>, or</li>
  <li>"<code>script</code>" and the MIME type is not a <a href="https://html.spec.whatwg.org/multipage/scripting.html#javascript-mime-type">JavaScript MIME type</a></li>
 </ul>
 </dd>
 <dd>Enables Cross-Origin Read Blocking (CORB) protection for the MIME-types:
 <ul>
  <li><code>text/html</code></li>
  <li><code>text/plain</code></li>
  <li><code>text/json</code>, <code>application/json</code> or any other type with a JSON extension: <code>*/*+json</code></li>
  <li><code>text/xml</code>, <code>application/xml</code> or any other type with an XML extension: <code>*/*+xml</code> (excluding <code>image/svg+xml</code>)</li>
 </ul>
 </dd>
</dl>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <tbody>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
  <tr>
   <td>{{SpecName("Fetch", "#x-content-type-options-header", "X-Content-Type-Options definition")}}</td>
   <td>{{Spec2("Fetch")}}</td>
   <td>Initial definition</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("http.headers.X-Content-Type-Options")}}</p>

<h3 id="Browser_specific_notes">Browser specific notes</h3>

<ul>
 <li>Firefox 72 enables <code>X-Content-Type-Options: nosniff</code> for top-level documents</li>
</ul>

<h2 id="See_also">See also</h2>

<ul>
 <li>{{HTTPHeader("Content-Type")}}</li>
 <li>The <a href="https://blogs.msdn.microsoft.com/ie/2008/09/02/ie8-security-part-vi-beta-2-update/">original definition</a> of X-Content-Type-Options by Microsoft.</li>
 <li>The <a href="https://observatory.mozilla.org/">Mozilla Observatory</a> tool testing the configuration (including this header) of Web sites for safety and security</li>
 <li><a href="https://blog.mozilla.org/security/2016/08/26/mitigating-mime-confusion-attacks-in-firefox/">Mitigating MIME Confusion Attacks in Firefox</a></li>
 <li><a href="https://fetch.spec.whatwg.org/#corb">Cross-Origin Read Blocking (CORB)</a></li>
 <li><a href="https://chromium.googlesource.com/chromium/src/+/master/services/network/cross_origin_read_blocking_explainer.md">Google Docs CORB explainer</a></li>
</ul>
